// --	-----	-----	-----	-----	-----	-----	-----	-----	-----	-----	-----	------
// Ping.CS								Presto, March '99 
//
//	The game of "Pong" (I know it's actually a breakout clone but 
//	"Pong" has a cooler name)
//
//	I would have never even thought to write this script had it not been
//	for an amazingly creative suggstion by GrymReaper...
//
//	Requires the PrestoPack v0.92 or higher
//
//	Installation:
//		1. Drop it in your config directory
//		2. Change this line from false to true:
$PrestoPref::Pong = true;
//		3. Change these keys as necessary:
$PrestoPref::PongUp = "numpad8";
$PrestoPref::PongDown = "numpad2";
$PrestoPref::PongStart = "numpad0";
$PrestoPref::PongToggle = "alt p";
//		4. Change the position as necessary
//			Specify as "X Y ROWS COLUMNS"
$PrestoPref::PongPosition = "10 75 9 7";
//		5. Adjust the rest of these parameters to your liking
$Pong::ballsPerGame = 3;
$Pong::gameSpeed = 3;		// increases with each level anyway
$Pong::frameRate = 0.05;	// probably shouldn't touch.  update speed.
//		6. Add it to your autoexec.cs if you want, or just exec(Ping); 
//			at the console.
//
// ---------------------------------------------------------------------------

Include("presto\\HUD.cs");
Include("presto\\Say.cs");

// ======================================
// Dyn routines
// ======================================

function Pong::PaddleDirY(%dir, %dy) {
	$Pong::paddle[%dir] = %dy;
	}
function Pong::BallDirY(%dy) {
	$Pong::ballDY = %dy;
	}
function Pong::BallDirX(%dx) {
	$Pong::ballDX = %dx;
	}

function Pong::MovePaddle() {
	if ($Pong::mode == demo)
		$Pong::paddleY = $Pong::ballY;
	else	{
		$Pong::paddleY += $Pong::paddle[up];
		$Pong::paddleY += $Pong::paddle[down];
		if ($Pong::paddleY < 0)
			$Pong::paddleY = 0;
		if ($Pong::paddleY > $Pong::rows * $Pong::brickSizeY - 1)
			$Pong::paddleY = $Pong::rows * $Pong::brickSizeY - 1;
		}
	Pong::DrawPaddle();
	}
function Pong::MoveBall() {
	if ($Pong::ballX == -999)
		return;

	%brickX = floor(($Pong::ballX + $Pong::ballDX) / $Pong::brickSizeX);
	%brickY = floor($Pong::ballY / $Pong::brickSizeY);
	if ($Pong::brickState[%brickX, %brickY] > 0) {
		$Pong::ballDX = -$Pong::ballDX;

		Pong::HitBrick(%brickX, %brickY);
		%hit = true;
		}

	%brickX = floor($Pong::ballX / $Pong::brickSizeX);
	%brickY = floor(($Pong::ballY + $Pong::ballDY) / $Pong::brickSizeY);
	if ($Pong::brickState[%brickX, %brickY] > 0) {
		$Pong::ballDY = -$Pong::ballDY;

		Pong::HitBrick(%brickX, %brickY);
		%hit = true;
		}

	if ($Pong::ballDX == 1 && $Pong::ballX >= $Pong::paddleX && $Pong::ballX < ($Pong::paddleX + 6)) {
		%d = $Pong::ballY - $Pong::paddleY;
		if (%d > -10 && %d < 10) {
			if (%d < -3) {
				if ($Pong::ballDY < 0)
					$Pong::ballDY--;
				else	$Pong::ballDY = -1;
				}
			else if (%d > 3) {
				if ($Pong::ballDY > 0)
					$Pong::ballDY++;
				else	$Pong::ballDY = 1;
				}
			$Pong::ballDX = -$Pong::ballDX;
			}
		}

	$Pong::ballY += $Pong::ballDY;
	if ($Pong::ballY >= $Pong::rows * $Pong::brickSizeY - 1) {
		$Pong::ballY = $Pong::rows * $Pong::brickSizeY - 1;
		$Pong::ballDY = -$Pong::ballDY;
		}
	else if ($Pong::ballY <= 0) {
		$Pong::ballY = 0;
		$Pong::ballDY = -$Pong::ballDY;
		}

	$Pong::ballX += $Pong::ballDX;
	if ($Pong::ballX >= 130)
		Pong::Miss();
	else if ($Pong::ballX <= 0) {
		$Pong::ballX = 0;
		$Pong::ballDX = -$Pong::ballDX;
		}
	
	if ($Pong::brickState == 0)
		Pong::NewLevel();
	else if (%hit)
		Pong::DrawBricks();

	Pong::DrawBall();
	}

function Pong::Update() {
	Pong::DisplayGameMode();
	for (%i = 0; %i < $Pong::speed; %i++) {
		Pong::MoveBall();
		if ((%i/2) == floor(%i/2))
			Pong::MovePaddle();
		}
	return $Pong::frameRate;
	}


function Pong::NewPlayfield() {
	%x = getWord($PrestoPref::PongPosition,0);
	%y = getWord($PrestoPref::PongPosition,1);
	%rows = getWord($PrestoPref::PongPosition,2);
	%cols = getWord($PrestoPref::PongPosition,3);

	if (%rows > 6)
		$Pong::rows = %rows;
	else	$Pong::rows = 6;

	if (%cols > 4)
		$Pong::cols = %cols;
	else	$Pong::cols = 4;

	HUD::NewFrame(hudPong, Pong::Update, %x,%y,200, $Pong::rows*$Pong::brickSizeY + 6);
	$Pong::ball = HUD::AddObject(hudPong, FearGuiFormattedText, 4,-2,200,$Pong::rows*$Pong::brickSizeY + 6);
	$Pong::objScore = HUD::AddObject(hudPong, FearGuiFormattedText, 0,0,200,$Pong::rows*$Pong::brickSizeY + 6);
	$objPaddle = HUD::AddObject(hudPong, FearGuiFormattedText, 4 + $Pong::paddleX,-2,50,$Pong::rows*$Pong::brickSizeY + 6);
	for (%c = 0; %c < %cols; %c++)
		$Pong::col[%c] = HUD::AddObject(hudPong, FearGuiFormattedText, 4+(%c * $Pong::brickSizeX),-2,$Pong::brickSizeX,$Pong::rows*$Pong::brickSizeY + 6);
	$objMessage = HUD::AddObject(hudPong, FearGuiFormattedText, 0,$Pong::rows*6-3,200,$Pong::brickSizeY);
	$Pong::mode="";
	Pong::SetGameMode(init);
	}

function Pong::NewBricks() {
	deleteVariables("$Pong::brickState*");
	$Pong::brickState = 0;
	for (%c = 0; %c < $Pong::cols; %c++) {
		for (%r = 0; %r < $Pong::rows; %r++) {
			if (%c == 0)
				%brick = 0;
			else if (getRandom() * 100 < $Pong::percent)
				%brick = 2;
			else	%brick = 1;
			$Pong::brickState[%c,%r] = %brick;
			$Pong::brickState += $Pong::brickState[%c,%r];
			}
		}
	Pong::DrawBricks();
	}
 function Pong::NewLevel() {
	if ($pong::mode == "play") {
		if ($Pong::percent < 100)
			$Pong::percent += 25;
		if ($Pong::speed < 10)
			$Pong::speed += 0.75;
		}
	Pong::NewBricks();
	Pong::NewBall();
	}
function Pong::NewBall() {
	$Pong::ballDY = 0;
	$Pong::ballDX = 0;
	$Pong::ballY = ($Pong::rows * $Pong::brickSizeY) / 2;
	$Pong::ballX = ($Pong::cols * $Pong::brickSizeX) + 3;
	if ($Pong::mode == "play") {
		Pong::DrawScore();
		Pong::PushGameMode(ready);
		}
	else	Pong::LaunchBall();
	}
function Pong::LaunchBall() {
	$Pong::ballDY = 1;
	$Pong::ballDX = 1;
	}

function Pong::HitBrick(%x,%y) {
	$Pong::brickState[%x, %y]--;
	$Pong::score++;
	Pong::DrawScore();

	$Pong::brickState--;
	}

function Pong::DrawBricks() {
	%rows = $Pong::rows;
	%cols = $Pong::cols;

	for (%c = 0; %c < %cols; %c++) {
		%str = "";
		for (%r = 0; %r < %rows; %r++) {
			%str = %str @ $Pong::brickImage[$Pong::brickState[%c,%r]] @ "\n";
			}
		Control::SetValue(Object::GetName($Pong::col[%c]), %str);
		}
	}
function Pong::DrawBall() {
	if ($Pong::ballX == -999)
		return;
	%str = "            <B"@ ($Pong::ballX-72) @","@ (3+$Pong::ballY) @":HW_Mid.bmp>";
	Control::SetValue(Object::GetName($Pong::ball), %str);
	}
function Pong::DrawScore() {
	%str = "<f0><jr>PING \nVersion \n1.0 by \nPresto \n";
	for (%line = 6; %line < $Pong::rows; %line++)
		%str = %str @ "\n";
	if ($Pong::mode == "play") {
		%str = %str @ "<f2>";
		for (%i = 0; %i < $Pong::balls; %i++)
			%str = %str@".";
		%str = %str @" \n"@ $Pong::score @" ";
		}
	else	{
		%str = %str @"\n<f0>"@ $Pong::score @" ";
		}
	Control::SetValue(Object::GetName($Pong::objScore), %str);
	}
function Pong::DrawPaddle() {
	%str = "<B0,"@ ($Pong::paddleY-3) @ ":HH_End_Green.bmp>";
	Control::SetValue(Object::GetName($objPaddle), %str);
	}

function Pong::DrawMessage(%msg) {
	Control::SetValue(Object::GetName($objMessage), "<jc>"@%msg);
	}

function Pong::ModeDemo( ) {
	$blink = !$blink;
	if ($blink) {
		Pong::DrawMessage("");
		Pong::CallModeAgain(0.5);
		}
	else	{
		Pong::DrawMessage($Pong::message[demo,$Pong::mode[demo]]);
		$Pong::mode[demo] += 1;
		if ($Pong::message[demo,$Pong::mode[demo]] == "")
			$Pong::mode[demo] = 0;
		Pong::CallModeAgain(1);
		}
	}

function Pong::Miss() {
	$Pong::ballX = -999;
	if ($Pong::mode == "play") {
		$Pong::balls--;
		Pong::DrawScore();
		if ($Pong::balls < 0) {
			Pong::SetGameMode(gameOver);
			return;
			}
		}
	Pong::PushGameMode(missed);
	}
function Pong::ModeMissed() {
	if ($Pong::mode[missed] >= 1) {
		Pong::DrawMessage("");
		Pong::PopGameMode();
		Pong::NewBall();
		return;
		}

	Say::Local(yellOops);
	Pong::DrawMessage("<f2>Oops!");
	$Pong::mode[missed]++;
	Pong::CallModeAgain(1);
	}
function Pong::ModeStartDemo() {
	HUD::Display(hudPong, $Pong::display);
	$Pong::score = 0;
	Pong::DrawScore();
	Pong::NewLevel();
	Pong::SetGameMode(demo);
	}
function Pong::ModePlay() {
	Pong::DrawMessage("");
	HUD::Display(hudPong, $Pong::display);
	$Pong::score = 0;
	$Pong::balls = $Pong::ballsPerGame;
	$Pong::speed = $Pong::gameSpeed - 0.75;
	$Pong::percent = -25;	// ugly but works (incremented in newlevel)
	Pong::DrawScore();
	Pong::NewLevel();
	}
function Pong::ModeGameOver() {
	if ($Pong::mode[gameover] >= 1) {
		Pong::SetGameMode(startDemo);
		return;
		}

	$Pong::mode[gameover]++;
	$Pong::message[demo,4] = "<f2>Last score: "@$Pong::score;
	if ($Pong::score <= $PrestoPref::pongHighScore) {
		Pong::DrawMessage("<f2>Game Over");
		Say::Local(yellDoh);
		Pong::CallModeAgain(1);
		}
	else	{
		Pong::DrawMessage("<f2>High Score!");
		Say::Local(yellWoohoo);
		$PrestoPref::pongHighScore = $Pong::score;
		$Pong::message[demo,5] = "<f2>High score: "@$Pong::score;
		Pong::CallModeAgain(2);
		}
	}
function Pong::ModeInit() {
	HUD::Display(hudPong, false);
	$Pong::modes = 0;
	$Pong::paddleY = 20;
	$Pong::ballX = -999;
	$Pong::speed = $Pong::gameSpeed;
	$Pong::nextModeTime = "";
	$Pong::message[demo,0] = "<f2>Demo Mode";
	$Pong::message[demo,1] = "<f2>Demo Mode";
	$Pong::message[demo,2] = "<f2>Press "@ $PrestoPref::PongStart @" to start";
	$Pong::message[demo,3] = "<f2>Demo Mode";
	$Pong::message[demo,4] = "";	// last score
	$Pong::message[demo,5] = "";	// high score
	$Pong::message[ready,0] = "<f2>Ready";
	$Pong::message[ready,1] = "<f2>3";
	$Pong::message[ready,2] = "<f2>2";
	$Pong::message[ready,3] = "<f2>1";
	$Pong::message[ready,4] = "";

	Pong::SetGameMode(startDemo);
	}
function Pong::ModeReady() {
	if ($Pong::mode != ready)
		return;

	Pong::DrawMessage($Pong::message[ready,$Pong::mode[ready]]);
	if ($Pong::mode[ready] >= 4) {
		Pong::PopGameMode();
		Pong::LaunchBall();
		Pong::DrawScore();
		return;
		}

	if ($Pong::mode[ready] == 0)
		Say::Local(orderReady);
	$Pong::mode[ready]++;
	Pong::CallModeAgain(0.5);
	}

function Pong::PushGameMode(%mode) {
	$Pong::oldMode[$Pong::modes] = $Pong::mode;
	$Pong::modes++;

	$Pong::mode = %mode;
	$Pong::mode[$Pong::mode] = 0;
	eval("Pong::Mode"@$Pong::mode@"();");
	}
function Pong::PopGameMode() {
	$Pong::modes--;
	$Pong::mode = $Pong::oldMode[$Pong::modes];
	}
function Pong::DisplayGameMode() {
	if ($Pong::nextModeTime == "" || getSimTime() < $Pong::nextModeTime)
		return;

	$Pong::nextModeTime = "";
	eval("Pong::Mode"@$Pong::mode@"();");
	}
function Pong::CallModeAgain(%time) {
	$Pong::nextModeTime = getSimTime() + %time;
	}

function Pong::SetGameMode(%mode) {
 	if ($Pong::mode == %mode)
		return;

	$Pong::mode = %mode;
	$Pong::mode[$Pong::mode] = 0;

	eval("Pong::Mode"@$Pong::mode@"();");
	}

function Pong::Toggle() {
	$Pong::display = !$Pong::display;
	HUD::Display(hudPong, $Pong::display);
	}

$Pong::paddleX = 121;
$Pong::brickSizeX = 9;
$Pong::brickSizeY = 13;
$Pong::brickImage[0] = "  ";
$Pong::brickImage[1] = "<f1>[]";
$Pong::brickImage[2] = "<f0>()";
$Pong::percent = 0;
$Pong::display = false;
Pong::NewPlayfield();

if (Presto::EnableOption(Pong)) {
	Presto::EnableKey(PongUp, play, "Pong::PaddleDirY(up,-3);", "Pong::PaddleDirY(up,0);");
	Presto::EnableKey(PongDown, play, "Pong::PaddleDirY(down,3);", "Pong::PaddleDirY(down,0);");
	Presto::EnableKey(PongStart, play, "Pong::SetGameMode(\"play\");");
	Presto::EnableKey(PongToggle, play, "Pong::Toggle();");
	}
